# Gravity Wells

_Forge gravity into your code. Shape time, distort space, and carve legacy into the architecture of tomorrow._

**Gravity Wells** is a lightweight CQRS and Event-Driven library, built to resonate with the spirit of domain-driven architectures.  
At its core lies the **Singularity** — a gravitational nexus where commands, queries, and events intertwine, bending the causal fabric of your systems.

---

## ✨ Philosophy

- **Commands** bend domain realities.
- **Queries** capture the light escaping from the core.
- **Events** ripple as gravitational waves across time.

Gravity Wells does not impose structures — it unlocks potential.  
It does not dictate architectures — it forges paths.

---

## 🧠 Core Principles

- **Hexagonal Architecture (Ports & Adapters) friendly**
- **Built for CQRS, Event Sourcing, and Saga orchestration**
- **Extensible through Command, Query, and Event Middlewares**
- **Zero external dependencies: pure minimalism**

---

## 🪐 Infinite Expansion

Gravity Wells is only the first fragment of a greater constellation:

- `gravitywells/sagas`: Saga orchestrators, weaving constellations of process.
- `gravitywells/observatory`: Observability to record the curvatures of events.
- `gravitywells/eventstorm`: A DSL for mapping event storms across untamed domains.

---

> _Commands are gravity wells.  
> Queries are photons escaping.  
> Events are echoes traveling eternally across the fabric of systems._

---

# 📜 License

**MIT** — because knowledge, like gravity, belongs to everyone.